/*----- PROTECTED REGION ID(SimulatedE2BPM.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        SimulatedE2BPM.h
//
// description : Include file for the SimulatedE2BPM class
//
// project :     SimulatedE2BPM
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef SimulatedE2BPM_H
#define SimulatedE2BPM_H

#include <tango/tango.h>

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  SimulatedE2BPM class description:
 *    Class implementing a simulated Elettra 2.0 BPM postion momitor
 */


namespace SimulatedE2BPM_ns
{
/*----- PROTECTED REGION ID(SimulatedE2BPM::Additional Class Declarations) ENABLED START -----*/
/* clang-format on */
//	Additional Class Declarations
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::Additional Class Declarations

class SimulatedE2BPM : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(SimulatedE2BPM::Data Members) ENABLED START -----*/
/* clang-format on */
//	Add your own data members
private:
	Tango::DeviceProxy* orbit_dev;
	std::vector<Tango::DevDouble> h_pos;
	std::vector<Tango::DevDouble> v_pos;
	std::vector<Tango::DevDouble> raw_h_pos_tbt;
	std::vector<Tango::DevDouble> raw_v_pos_tbt;
	std::vector<Tango::DevDouble> h_pos_tbt;
	std::vector<Tango::DevDouble> v_pos_tbt;
	int n_turns;
	int n_bpms;
protected:
	Tango::DevDouble injected_curr;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::Data Members

//	Device property data members
public:
	//	MemHorOffset:	Memorized Horizontal offset [mm]
	Tango::DevDouble	memHorOffset;
	//	MemVerOffset:	Memorized Vertical offset [mm]
	Tango::DevDouble	memVerOffset;
	//	Index:	BPM index in oribit vector
	Tango::DevULong	index;
	//	Name:	BPM component name
	std::string	name;
	//	CurrToSum:	scaling factor for converting machine current to sum signal
	Tango::DevDouble	currToSum;
	//	OrbitDevName:	Tango device name of simulatedebeamorbit-srv.
	//  simulatedebeamorbit-srv acts as buffer for limiting the load to the ring simulator.
	std::string	orbitDevName;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_HorOffset_read;
	Tango::DevDouble	*attr_HorPos_read;
	Tango::DevDouble	*attr_Sum_read;
	Tango::DevULong64	*attr_BufSize_read;
	Tango::DevBoolean	*attr_tbtEnable_read;
	Tango::DevDouble	*attr_VerOffset_read;
	Tango::DevDouble	*attr_VerPos_read;
	Tango::DevDouble	*attr_rawHorPos_read;
	Tango::DevDouble	*attr_rawVerPos_read;
	Tango::DevDouble	*attr_ScaleFactor_read;
	Tango::DevDouble	*attr_HorPosHistory_read;
	Tango::DevDouble	*attr_VerPosHistory_read;
	Tango::DevDouble	*attr_SumHistory_read;
	Tango::DevDouble	*attr_rawHorPosHistory_read;
	Tango::DevDouble	*attr_rawVerPosHistory_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	SimulatedE2BPM(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	SimulatedE2BPM(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	SimulatedE2BPM(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~SimulatedE2BPM();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : SimulatedE2BPM::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : SimulatedE2BPM::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute HorOffset related methods
 *	Description: horizontal BPM offset - default 0
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_HorOffset(Tango::Attribute &attr);
	virtual void write_HorOffset(Tango::WAttribute &attr);
	virtual bool is_HorOffset_allowed(Tango::AttReqType type);
/**
 *	Attribute HorPos related methods
 *	Description: Horizontal position [mm] readout, including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_HorPos(Tango::Attribute &attr);
	virtual bool is_HorPos_allowed(Tango::AttReqType type);
/**
 *	Attribute Sum related methods
 *	Description: Sum signal proprtional to beam current
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Sum(Tango::Attribute &attr);
	virtual bool is_Sum_allowed(Tango::AttReqType type);
/**
 *	Attribute BufSize related methods
 *	Description: Turn by turn buffer size
 *
 *	Data type:	Tango::DevULong64
 *	Attr type:	Scalar
 */
	virtual void read_BufSize(Tango::Attribute &attr);
	virtual void write_BufSize(Tango::WAttribute &attr);
	virtual bool is_BufSize_allowed(Tango::AttReqType type);
/**
 *	Attribute tbtEnable related methods
 *	Description: Enable the turn by turn mode
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_tbtEnable(Tango::Attribute &attr);
	virtual void write_tbtEnable(Tango::WAttribute &attr);
	virtual bool is_tbtEnable_allowed(Tango::AttReqType type);
/**
 *	Attribute VerOffset related methods
 *	Description: vertical BPM offset - default 0
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_VerOffset(Tango::Attribute &attr);
	virtual void write_VerOffset(Tango::WAttribute &attr);
	virtual bool is_VerOffset_allowed(Tango::AttReqType type);
/**
 *	Attribute VerPos related methods
 *	Description: Vertical position [mm] readout , including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_VerPos(Tango::Attribute &attr);
	virtual bool is_VerPos_allowed(Tango::AttReqType type);
/**
 *	Attribute rawHorPos related methods
 *	Description: Raw horizontal position read from simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_rawHorPos(Tango::Attribute &attr);
	virtual bool is_rawHorPos_allowed(Tango::AttReqType type);
/**
 *	Attribute rawVerPos related methods
 *	Description: Raw  vertical position read from simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_rawVerPos(Tango::Attribute &attr);
	virtual bool is_rawVerPos_allowed(Tango::AttReqType type);
/**
 *	Attribute injectCurr related methods
 *	Description: attribute to injtect from the machine model the beam current
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void write_injectCurr(Tango::WAttribute &attr);
	virtual bool is_injectCurr_allowed(Tango::AttReqType type);
/**
 *	Attribute ScaleFactor related methods
 *	Description: write the scaling factor used to covert injected (raw )Position  to read-out Positions
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ScaleFactor(Tango::Attribute &attr);
	virtual void write_ScaleFactor(Tango::WAttribute &attr);
	virtual bool is_ScaleFactor_allowed(Tango::AttReqType type);
/**
 *	Attribute HorPosHistory related methods
 *	Description: Turn by turn horizontal position, including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
	virtual void read_HorPosHistory(Tango::Attribute &attr);
	virtual bool is_HorPosHistory_allowed(Tango::AttReqType type);
/**
 *	Attribute VerPosHistory related methods
 *	Description: Turn by turn vertical  position, including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
	virtual void read_VerPosHistory(Tango::Attribute &attr);
	virtual bool is_VerPosHistory_allowed(Tango::AttReqType type);
/**
 *	Attribute SumHistory related methods
 *	Description: Turn by turn sum signal
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
	virtual void read_SumHistory(Tango::Attribute &attr);
	virtual bool is_SumHistory_allowed(Tango::AttReqType type);
/**
 *	Attribute rawHorPosHistory related methods
 *	Description: Raw turn by turn horizontal position as read form simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
	virtual void read_rawHorPosHistory(Tango::Attribute &attr);
	virtual bool is_rawHorPosHistory_allowed(Tango::AttReqType type);
/**
 *	Attribute rawVerPosHistory related methods
 *	Description: Raw turn by turn vertical position as read form simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
	virtual void read_rawVerPosHistory(Tango::Attribute &attr);
	virtual bool is_rawVerPosHistory_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : SimulatedE2BPM::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command Reset related method
	 *	Description: Reset to normal condition - recover form disabled state
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command GetBPMName related method
	 *	Description: Get official BPM name
	 *
	 *	@returns
	 */
	virtual Tango::DevString get_bpmname();
	virtual bool is_GetBPMName_allowed(const CORBA::Any &any);
	/**
	 *	Command GetBPMIndex related method
	 *	Description: Get index of BPM in global orbit
	 *
	 *	@returns
	 */
	virtual Tango::DevULong get_bpmindex();
	virtual bool is_GetBPMIndex_allowed(const CORBA::Any &any);
	/**
	 *	Command Fault related method
	 *	Description: Force BPM to Fault state - simulate error
	 *
	 */
	virtual void fault();
	virtual bool is_Fault_allowed(const CORBA::Any &any);
	/**
	 *	Command On related method
	 *	Description: Force BPM to ON  state and recover from simulated error
	 *
	 */
	virtual void on();
	virtual bool is_On_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : SimulatedE2BPM::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(SimulatedE2BPM::Additional Method prototypes) ENABLED START -----*/
/* clang-format on */
//	Additional Method prototypes
/* clang-format off */
	void update_offset_scale();
	void n_turns_new_value();
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::Additional Method prototypes
};

/*----- PROTECTED REGION ID(SimulatedE2BPM::Additional Classes Definitions) ENABLED START -----*/
/* clang-format on */
//	Additional Classes Definitions
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::Additional Classes Definitions

}	//	End of namespace

#endif   //	SimulatedE2BPM_H
