/*----- PROTECTED REGION ID(SimulatedE2BPMClass.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        SimulatedE2BPMClass.cpp
//
// description : C++ source for the SimulatedE2BPMClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the SimulatedE2BPM once per process.
//
// project :     SimulatedE2BPM
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "SimulatedE2BPMClass.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass.cpp

//-------------------------------------------------------------------
/**
 *	Create SimulatedE2BPMClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_SimulatedE2BPM_class(const char *name) {
		return SimulatedE2BPM_ns::SimulatedE2BPMClass::init(name);
	}
}

namespace SimulatedE2BPM_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
SimulatedE2BPMClass *SimulatedE2BPMClass::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
constexpr long HorPosHistoryAttrib::X_DATA_SIZE;
constexpr long VerPosHistoryAttrib::X_DATA_SIZE;
constexpr long SumHistoryAttrib::X_DATA_SIZE;
constexpr long rawHorPosHistoryAttrib::X_DATA_SIZE;
constexpr long rawVerPosHistoryAttrib::X_DATA_SIZE;
//--------------------------------------------------------
/**
 * method : 		SimulatedE2BPMClass::SimulatedE2BPMClass(std::string &s)
 * description : 	constructor for the SimulatedE2BPMClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
SimulatedE2BPMClass::SimulatedE2BPMClass(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering SimulatedE2BPMClass constructor" << std::endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::constructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::constructor

	TANGO_LOG_INFO << "Leaving SimulatedE2BPMClass constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		SimulatedE2BPMClass::~SimulatedE2BPMClass()
 * description : 	destructor for the SimulatedE2BPMClass
 */
//--------------------------------------------------------
SimulatedE2BPMClass::~SimulatedE2BPMClass()
{
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::destructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		SimulatedE2BPMClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
SimulatedE2BPMClass *SimulatedE2BPMClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new SimulatedE2BPMClass(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		SimulatedE2BPMClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
SimulatedE2BPMClass *SimulatedE2BPMClass::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetClass::execute(): arrived" << std::endl;
	((static_cast<SimulatedE2BPM *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetBPMNameClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetBPMNameClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "GetBPMNameClass::execute(): arrived" << std::endl;
	return insert((static_cast<SimulatedE2BPM *>(device))->get_bpmname());
}

//--------------------------------------------------------
/**
 * method : 		GetBPMIndexClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetBPMIndexClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "GetBPMIndexClass::execute(): arrived" << std::endl;
	return insert((static_cast<SimulatedE2BPM *>(device))->get_bpmindex());
}

//--------------------------------------------------------
/**
 * method : 		FaultClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *FaultClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "FaultClass::execute(): arrived" << std::endl;
	((static_cast<SimulatedE2BPM *>(device))->fault());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "OnClass::execute(): arrived" << std::endl;
	((static_cast<SimulatedE2BPM *>(device))->on());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum SimulatedE2BPMClass::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum SimulatedE2BPMClass::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum SimulatedE2BPMClass::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::get_class_property()
 *	Description: Read database to initialize class property data members.
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::get_class_property()
{
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::get_class_property_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialize class property data members
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::get_class_property_before
	//	Read class properties from database.
	cl_prop.push_back(Tango::DbDatum("OrbitDevName"));

	//	Call database and extract values
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;

	//	Try to extract OrbitDevName value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  orbitDevName;
	else
	{
		//	Check default value for OrbitDevName
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  orbitDevName;
			cl_prop[i]  <<  orbitDevName;
		}
	}
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::get_class_property_after) ENABLED START -----*/
	/* clang-format on */
	//	Check class property data members init
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::get_class_property_after

}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties
	prop_name = "OrbitDevName";
	prop_desc = "Tango device name of simulatedebeamorbit-srv.\nsimulatedebeamorbit-srv acts as buffer for limiting the load to the ring simulator.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);

	//	Set Default device Properties
	prop_name = "MemHorOffset";
	prop_desc = "Memorized Horizontal offset [mm]";
	prop_def  = "0.0";
	vect_data.clear();
	vect_data.push_back("0.0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MemVerOffset";
	prop_desc = "Memorized Vertical offset [mm]";
	prop_def  = "0.0";
	vect_data.clear();
	vect_data.push_back("0.0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Index";
	prop_desc = "BPM index in oribit vector";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Name";
	prop_desc = "BPM component name";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CurrToSum";
	prop_desc = "scaling factor for converting machine current to sum signal";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "OrbitDevName";
	prop_desc = "Tango device name of simulatedebeamorbit-srv.\nsimulatedebeamorbit-srv acts as buffer for limiting the load to the ring simulator.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("SimulatedE2BPM");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("Class implementing a simulated Elettra 2.0 BPM postion momitor");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::device_factory_before) ENABLED START -----*/
/* clang-format on */
//	Add your own code
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new SimulatedE2BPM(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		SimulatedE2BPM *dev = static_cast<SimulatedE2BPM *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::device_factory_after) ENABLED START -----*/
/* clang-format on */
//	Add your own code
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::attribute_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::attribute_factory_before
	//	Attribute : HorOffset
	HorOffsetAttrib	*horoffset = new HorOffsetAttrib();
	Tango::UserDefaultAttrProp	horoffset_prop;
	horoffset_prop.set_description("horizontal BPM offset - default 0");
	horoffset_prop.set_label("horizontal offset");
	horoffset_prop.set_unit("mm");
	horoffset_prop.set_standard_unit("1.0");
	horoffset_prop.set_display_unit("mm");
	horoffset_prop.set_format("%6.2f");
	//	max_value	not set for HorOffset
	//	min_value	not set for HorOffset
	//	max_alarm	not set for HorOffset
	//	min_alarm	not set for HorOffset
	//	max_warning	not set for HorOffset
	//	min_warning	not set for HorOffset
	//	delta_t	not set for HorOffset
	//	delta_val	not set for HorOffset
	horoffset->set_default_properties(horoffset_prop);
	//	Not Polled
	horoffset->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(horoffset);

	//	Attribute : HorPos
	HorPosAttrib	*horpos = new HorPosAttrib();
	Tango::UserDefaultAttrProp	horpos_prop;
	horpos_prop.set_description("Horizontal position [mm] readout, including offsets and scale factors");
	horpos_prop.set_label("horizontal position");
	horpos_prop.set_unit("mm");
	horpos_prop.set_standard_unit("1.0");
	horpos_prop.set_display_unit("mm");
	horpos_prop.set_format("%.6e");
	horpos_prop.set_max_value("1000");
	horpos_prop.set_min_value("-1000");
	//	max_alarm	not set for HorPos
	//	min_alarm	not set for HorPos
	//	max_warning	not set for HorPos
	//	min_warning	not set for HorPos
	//	delta_t	not set for HorPos
	//	delta_val	not set for HorPos
	horpos->set_default_properties(horpos_prop);
	//	Not Polled
	horpos->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(horpos);

	//	Attribute : Sum
	SumAttrib	*sum = new SumAttrib();
	Tango::UserDefaultAttrProp	sum_prop;
	sum_prop.set_description("Sum signal proprtional to beam current");
	sum_prop.set_label("sum");
	sum_prop.set_unit("a.u.");
	//	standard_unit	not set for Sum
	//	display_unit	not set for Sum
	//	format	not set for Sum
	//	max_value	not set for Sum
	//	min_value	not set for Sum
	//	max_alarm	not set for Sum
	//	min_alarm	not set for Sum
	//	max_warning	not set for Sum
	//	min_warning	not set for Sum
	//	delta_t	not set for Sum
	//	delta_val	not set for Sum
	sum->set_default_properties(sum_prop);
	//	Not Polled
	sum->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sum);

	//	Attribute : BufSize
	BufSizeAttrib	*bufsize = new BufSizeAttrib();
	Tango::UserDefaultAttrProp	bufsize_prop;
	bufsize_prop.set_description("Turn by turn buffer size");
	bufsize_prop.set_label("tbt buffer size");
	//	unit	not set for BufSize
	//	standard_unit	not set for BufSize
	//	display_unit	not set for BufSize
	//	format	not set for BufSize
	bufsize_prop.set_max_value("99999999");
	bufsize_prop.set_min_value("1");
	//	max_alarm	not set for BufSize
	//	min_alarm	not set for BufSize
	//	max_warning	not set for BufSize
	//	min_warning	not set for BufSize
	//	delta_t	not set for BufSize
	//	delta_val	not set for BufSize
	bufsize->set_default_properties(bufsize_prop);
	//	Not Polled
	bufsize->set_disp_level(Tango::EXPERT);
	bufsize->set_memorized();
	bufsize->set_memorized_init(true);
	att_list.push_back(bufsize);

	//	Attribute : tbtEnable
	tbtEnableAttrib	*tbtenable = new tbtEnableAttrib();
	Tango::UserDefaultAttrProp	tbtenable_prop;
	tbtenable_prop.set_description("Enable the turn by turn mode");
	tbtenable_prop.set_label("turn by turn");
	//	unit	not set for tbtEnable
	//	standard_unit	not set for tbtEnable
	//	display_unit	not set for tbtEnable
	//	format	not set for tbtEnable
	//	max_value	not set for tbtEnable
	//	min_value	not set for tbtEnable
	//	max_alarm	not set for tbtEnable
	//	min_alarm	not set for tbtEnable
	//	max_warning	not set for tbtEnable
	//	min_warning	not set for tbtEnable
	//	delta_t	not set for tbtEnable
	//	delta_val	not set for tbtEnable
	tbtenable->set_default_properties(tbtenable_prop);
	//	Not Polled
	tbtenable->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(tbtenable);

	//	Attribute : VerOffset
	VerOffsetAttrib	*veroffset = new VerOffsetAttrib();
	Tango::UserDefaultAttrProp	veroffset_prop;
	veroffset_prop.set_description("vertical BPM offset - default 0");
	veroffset_prop.set_label("vertical offset");
	veroffset_prop.set_unit("mm");
	veroffset_prop.set_standard_unit("1.0");
	veroffset_prop.set_display_unit("mm");
	veroffset_prop.set_format("%.6f");
	veroffset_prop.set_max_value("1000");
	veroffset_prop.set_min_value("-1000");
	//	max_alarm	not set for VerOffset
	//	min_alarm	not set for VerOffset
	//	max_warning	not set for VerOffset
	//	min_warning	not set for VerOffset
	//	delta_t	not set for VerOffset
	//	delta_val	not set for VerOffset
	veroffset->set_default_properties(veroffset_prop);
	//	Not Polled
	veroffset->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(veroffset);

	//	Attribute : VerPos
	VerPosAttrib	*verpos = new VerPosAttrib();
	Tango::UserDefaultAttrProp	verpos_prop;
	verpos_prop.set_description("Vertical position [mm] readout , including offsets and scale factors");
	verpos_prop.set_label("vertical position");
	verpos_prop.set_unit("mm");
	verpos_prop.set_standard_unit("1.0");
	verpos_prop.set_display_unit("mm");
	verpos_prop.set_format("%.6e");
	verpos_prop.set_max_value("1000");
	verpos_prop.set_min_value("-1000");
	//	max_alarm	not set for VerPos
	//	min_alarm	not set for VerPos
	//	max_warning	not set for VerPos
	//	min_warning	not set for VerPos
	//	delta_t	not set for VerPos
	//	delta_val	not set for VerPos
	verpos->set_default_properties(verpos_prop);
	//	Not Polled
	verpos->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(verpos);

	//	Attribute : rawHorPos
	rawHorPosAttrib	*rawhorpos = new rawHorPosAttrib();
	Tango::UserDefaultAttrProp	rawhorpos_prop;
	rawhorpos_prop.set_description("Raw horizontal position read from simulator");
	rawhorpos_prop.set_label("raw horizontal beam position");
	rawhorpos_prop.set_unit("m");
	rawhorpos_prop.set_standard_unit("1");
	rawhorpos_prop.set_display_unit("m");
	rawhorpos_prop.set_format("%.6e");
	rawhorpos_prop.set_max_value("1000");
	rawhorpos_prop.set_min_value("-1000");
	//	max_alarm	not set for rawHorPos
	//	min_alarm	not set for rawHorPos
	//	max_warning	not set for rawHorPos
	//	min_warning	not set for rawHorPos
	//	delta_t	not set for rawHorPos
	//	delta_val	not set for rawHorPos
	rawhorpos->set_default_properties(rawhorpos_prop);
	//	Not Polled
	rawhorpos->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(rawhorpos);

	//	Attribute : rawVerPos
	rawVerPosAttrib	*rawverpos = new rawVerPosAttrib();
	Tango::UserDefaultAttrProp	rawverpos_prop;
	rawverpos_prop.set_description("Raw  vertical position read from simulator");
	rawverpos_prop.set_label("raw vertical beam position");
	rawverpos_prop.set_unit("m");
	rawverpos_prop.set_standard_unit("1");
	rawverpos_prop.set_display_unit("m");
	rawverpos_prop.set_format("%.6e");
	rawverpos_prop.set_max_value("1000");
	rawverpos_prop.set_min_value("-1000");
	//	max_alarm	not set for rawVerPos
	//	min_alarm	not set for rawVerPos
	//	max_warning	not set for rawVerPos
	//	min_warning	not set for rawVerPos
	//	delta_t	not set for rawVerPos
	//	delta_val	not set for rawVerPos
	rawverpos->set_default_properties(rawverpos_prop);
	//	Not Polled
	rawverpos->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(rawverpos);

	//	Attribute : injectCurr
	injectCurrAttrib	*injectcurr = new injectCurrAttrib();
	Tango::UserDefaultAttrProp	injectcurr_prop;
	injectcurr_prop.set_description("attribute to injtect from the machine model the beam current");
	//	label	not set for injectCurr
	//	unit	not set for injectCurr
	//	standard_unit	not set for injectCurr
	//	display_unit	not set for injectCurr
	//	format	not set for injectCurr
	//	max_value	not set for injectCurr
	//	min_value	not set for injectCurr
	//	max_alarm	not set for injectCurr
	//	min_alarm	not set for injectCurr
	//	max_warning	not set for injectCurr
	//	min_warning	not set for injectCurr
	//	delta_t	not set for injectCurr
	//	delta_val	not set for injectCurr
	injectcurr->set_default_properties(injectcurr_prop);
	//	Not Polled
	injectcurr->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(injectcurr);

	//	Attribute : ScaleFactor
	ScaleFactorAttrib	*scalefactor = new ScaleFactorAttrib();
	Tango::UserDefaultAttrProp	scalefactor_prop;
	scalefactor_prop.set_description("write the scaling factor used to covert injected (raw )Position  to read-out Positions");
	scalefactor_prop.set_label("sacling factor");
	//	unit	not set for ScaleFactor
	//	standard_unit	not set for ScaleFactor
	//	display_unit	not set for ScaleFactor
	//	format	not set for ScaleFactor
	//	max_value	not set for ScaleFactor
	//	min_value	not set for ScaleFactor
	//	max_alarm	not set for ScaleFactor
	//	min_alarm	not set for ScaleFactor
	//	max_warning	not set for ScaleFactor
	//	min_warning	not set for ScaleFactor
	//	delta_t	not set for ScaleFactor
	//	delta_val	not set for ScaleFactor
	scalefactor->set_default_properties(scalefactor_prop);
	//	Not Polled
	scalefactor->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(scalefactor);

	//	Attribute : HorPosHistory
	HorPosHistoryAttrib	*horposhistory = new HorPosHistoryAttrib();
	Tango::UserDefaultAttrProp	horposhistory_prop;
	horposhistory_prop.set_description("Turn by turn horizontal position, including offsets and scale factors");
	horposhistory_prop.set_label("horizontal position history");
	horposhistory_prop.set_unit("mm");
	horposhistory_prop.set_standard_unit("1.0");
	horposhistory_prop.set_display_unit("mm");
	horposhistory_prop.set_format("%.6f");
	//	max_value	not set for HorPosHistory
	//	min_value	not set for HorPosHistory
	//	max_alarm	not set for HorPosHistory
	//	min_alarm	not set for HorPosHistory
	//	max_warning	not set for HorPosHistory
	//	min_warning	not set for HorPosHistory
	//	delta_t	not set for HorPosHistory
	//	delta_val	not set for HorPosHistory
	horposhistory->set_default_properties(horposhistory_prop);
	//	Not Polled
	horposhistory->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(horposhistory);

	//	Attribute : VerPosHistory
	VerPosHistoryAttrib	*verposhistory = new VerPosHistoryAttrib();
	Tango::UserDefaultAttrProp	verposhistory_prop;
	verposhistory_prop.set_description("Turn by turn vertical  position, including offsets and scale factors");
	verposhistory_prop.set_label("vertical position history");
	verposhistory_prop.set_unit("mm");
	verposhistory_prop.set_standard_unit("1.0");
	verposhistory_prop.set_display_unit("mm");
	verposhistory_prop.set_format("%.6f");
	verposhistory_prop.set_max_value("1000");
	verposhistory_prop.set_min_value("-1000");
	//	max_alarm	not set for VerPosHistory
	//	min_alarm	not set for VerPosHistory
	//	max_warning	not set for VerPosHistory
	//	min_warning	not set for VerPosHistory
	//	delta_t	not set for VerPosHistory
	//	delta_val	not set for VerPosHistory
	verposhistory->set_default_properties(verposhistory_prop);
	//	Not Polled
	verposhistory->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(verposhistory);

	//	Attribute : SumHistory
	SumHistoryAttrib	*sumhistory = new SumHistoryAttrib();
	Tango::UserDefaultAttrProp	sumhistory_prop;
	sumhistory_prop.set_description("Turn by turn sum signal");
	sumhistory_prop.set_label("sum history");
	//	unit	not set for SumHistory
	//	standard_unit	not set for SumHistory
	//	display_unit	not set for SumHistory
	//	format	not set for SumHistory
	//	max_value	not set for SumHistory
	//	min_value	not set for SumHistory
	//	max_alarm	not set for SumHistory
	//	min_alarm	not set for SumHistory
	//	max_warning	not set for SumHistory
	//	min_warning	not set for SumHistory
	//	delta_t	not set for SumHistory
	//	delta_val	not set for SumHistory
	sumhistory->set_default_properties(sumhistory_prop);
	//	Not Polled
	sumhistory->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sumhistory);

	//	Attribute : rawHorPosHistory
	rawHorPosHistoryAttrib	*rawhorposhistory = new rawHorPosHistoryAttrib();
	Tango::UserDefaultAttrProp	rawhorposhistory_prop;
	rawhorposhistory_prop.set_description("Raw turn by turn horizontal position as read form simulator");
	rawhorposhistory_prop.set_label("raw horizontal position history");
	rawhorposhistory_prop.set_unit("m");
	rawhorposhistory_prop.set_standard_unit("1.0");
	rawhorposhistory_prop.set_display_unit("m");
	rawhorposhistory_prop.set_format("%.6e");
	//	max_value	not set for rawHorPosHistory
	//	min_value	not set for rawHorPosHistory
	//	max_alarm	not set for rawHorPosHistory
	//	min_alarm	not set for rawHorPosHistory
	//	max_warning	not set for rawHorPosHistory
	//	min_warning	not set for rawHorPosHistory
	//	delta_t	not set for rawHorPosHistory
	//	delta_val	not set for rawHorPosHistory
	rawhorposhistory->set_default_properties(rawhorposhistory_prop);
	//	Not Polled
	rawhorposhistory->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(rawhorposhistory);

	//	Attribute : rawVerPosHistory
	rawVerPosHistoryAttrib	*rawverposhistory = new rawVerPosHistoryAttrib();
	Tango::UserDefaultAttrProp	rawverposhistory_prop;
	rawverposhistory_prop.set_description("Raw turn by turn vertical position as read form simulator");
	rawverposhistory_prop.set_label("raw vertical position history");
	rawverposhistory_prop.set_unit("m");
	rawverposhistory_prop.set_standard_unit("1.0");
	rawverposhistory_prop.set_display_unit("m");
	rawverposhistory_prop.set_format("%.6e");
	//	max_value	not set for rawVerPosHistory
	//	min_value	not set for rawVerPosHistory
	//	max_alarm	not set for rawVerPosHistory
	//	min_alarm	not set for rawVerPosHistory
	//	max_warning	not set for rawVerPosHistory
	//	min_warning	not set for rawVerPosHistory
	//	delta_t	not set for rawVerPosHistory
	//	delta_val	not set for rawVerPosHistory
	rawverposhistory->set_default_properties(rawverposhistory_prop);
	//	Not Polled
	rawverposhistory->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(rawverposhistory);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::attribute_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::pipe_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::pipe_factory_before
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::pipe_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::command_factory()
{
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::command_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::command_factory_before


	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command GetBPMName
	GetBPMNameClass	*pGetBPMNameCmd =
		new GetBPMNameClass("GetBPMName",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetBPMNameCmd);

	//	Command GetBPMIndex
	GetBPMIndexClass	*pGetBPMIndexCmd =
		new GetBPMIndexClass("GetBPMIndex",
			Tango::DEV_VOID, Tango::DEV_ULONG,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetBPMIndexCmd);

	//	Command Fault
	FaultClass	*pFaultCmd =
		new FaultClass("Fault",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pFaultCmd);

	//	Command On
	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);

	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::command_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		SimulatedE2BPMClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		std::transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::create_static_att_list) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		SimulatedE2BPMClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void SimulatedE2BPMClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		SimulatedE2BPM *dev = static_cast<SimulatedE2BPM *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::erase_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPMClass::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *SimulatedE2BPMClass::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(SimulatedE2BPMClass::Additional Methods) ENABLED START -----*/
/* clang-format on */
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::Additional Methods
} //	namespace
