/*----- PROTECTED REGION ID(SimulatedE2BPMClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        SimulatedE2BPMClass.h
//
// description : Include for the SimulatedE2BPM root class.
//               This class is the singleton class for
//                the SimulatedE2BPM device class.
//               It contains all properties and methods which the
//               SimulatedE2BPM requires only once e.g. the commands.
//
// project :     SimulatedE2BPM
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef SimulatedE2BPMClass_H
#define SimulatedE2BPMClass_H

#include <tango/tango.h>
#include "SimulatedE2BPM.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass.h


namespace SimulatedE2BPM_ns
{
/*----- PROTECTED REGION ID(SimulatedE2BPMClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute HorOffset class definition
class HorOffsetAttrib: public Tango::Attr
{
public:
	HorOffsetAttrib():Attr("HorOffset",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~HorOffsetAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_HorOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->write_HorOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_HorOffset_allowed(ty);}
};

//	Attribute HorPos class definition
class HorPosAttrib: public Tango::Attr
{
public:
	HorPosAttrib():Attr("HorPos",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~HorPosAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_HorPos(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_HorPos_allowed(ty);}
};

//	Attribute Sum class definition
class SumAttrib: public Tango::Attr
{
public:
	SumAttrib():Attr("Sum",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~SumAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_Sum(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_Sum_allowed(ty);}
};

//	Attribute BufSize class definition
class BufSizeAttrib: public Tango::Attr
{
public:
	BufSizeAttrib():Attr("BufSize",
			Tango::DEV_ULONG64, Tango::READ_WRITE) {}
	~BufSizeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_BufSize(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->write_BufSize(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_BufSize_allowed(ty);}
};

//	Attribute tbtEnable class definition
class tbtEnableAttrib: public Tango::Attr
{
public:
	tbtEnableAttrib():Attr("tbtEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~tbtEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_tbtEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->write_tbtEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_tbtEnable_allowed(ty);}
};

//	Attribute VerOffset class definition
class VerOffsetAttrib: public Tango::Attr
{
public:
	VerOffsetAttrib():Attr("VerOffset",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~VerOffsetAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_VerOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->write_VerOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_VerOffset_allowed(ty);}
};

//	Attribute VerPos class definition
class VerPosAttrib: public Tango::Attr
{
public:
	VerPosAttrib():Attr("VerPos",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~VerPosAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_VerPos(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_VerPos_allowed(ty);}
};

//	Attribute rawHorPos class definition
class rawHorPosAttrib: public Tango::Attr
{
public:
	rawHorPosAttrib():Attr("rawHorPos",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~rawHorPosAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_rawHorPos(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_rawHorPos_allowed(ty);}
};

//	Attribute rawVerPos class definition
class rawVerPosAttrib: public Tango::Attr
{
public:
	rawVerPosAttrib():Attr("rawVerPos",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~rawVerPosAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_rawVerPos(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_rawVerPos_allowed(ty);}
};

//	Attribute injectCurr class definition
class injectCurrAttrib: public Tango::Attr
{
public:
	injectCurrAttrib():Attr("injectCurr",
			Tango::DEV_DOUBLE, Tango::WRITE) {}
	~injectCurrAttrib() {}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->write_injectCurr(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_injectCurr_allowed(ty);}
};

//	Attribute ScaleFactor class definition
class ScaleFactorAttrib: public Tango::Attr
{
public:
	ScaleFactorAttrib():Attr("ScaleFactor",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~ScaleFactorAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_ScaleFactor(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->write_ScaleFactor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_ScaleFactor_allowed(ty);}
};

//	Attribute HorPosHistory class definition
class HorPosHistoryAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for HorPosHistory attribute
	constexpr static long X_DATA_SIZE = 10000;
	HorPosHistoryAttrib():SpectrumAttr("HorPosHistory",
			Tango::DEV_DOUBLE, Tango::READ, HorPosHistoryAttrib::X_DATA_SIZE) {}
	~HorPosHistoryAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_HorPosHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_HorPosHistory_allowed(ty);}
};

//	Attribute VerPosHistory class definition
class VerPosHistoryAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for VerPosHistory attribute
	constexpr static long X_DATA_SIZE = 10000;
	VerPosHistoryAttrib():SpectrumAttr("VerPosHistory",
			Tango::DEV_DOUBLE, Tango::READ, VerPosHistoryAttrib::X_DATA_SIZE) {}
	~VerPosHistoryAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_VerPosHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_VerPosHistory_allowed(ty);}
};

//	Attribute SumHistory class definition
class SumHistoryAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for SumHistory attribute
	constexpr static long X_DATA_SIZE = 10000;
	SumHistoryAttrib():SpectrumAttr("SumHistory",
			Tango::DEV_DOUBLE, Tango::READ, SumHistoryAttrib::X_DATA_SIZE) {}
	~SumHistoryAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_SumHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_SumHistory_allowed(ty);}
};

//	Attribute rawHorPosHistory class definition
class rawHorPosHistoryAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for rawHorPosHistory attribute
	constexpr static long X_DATA_SIZE = 10000;
	rawHorPosHistoryAttrib():SpectrumAttr("rawHorPosHistory",
			Tango::DEV_DOUBLE, Tango::READ, rawHorPosHistoryAttrib::X_DATA_SIZE) {}
	~rawHorPosHistoryAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_rawHorPosHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_rawHorPosHistory_allowed(ty);}
};

//	Attribute rawVerPosHistory class definition
class rawVerPosHistoryAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for rawVerPosHistory attribute
	constexpr static long X_DATA_SIZE = 10000;
	rawVerPosHistoryAttrib():SpectrumAttr("rawVerPosHistory",
			Tango::DEV_DOUBLE, Tango::READ, rawVerPosHistoryAttrib::X_DATA_SIZE) {}
	~rawVerPosHistoryAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SimulatedE2BPM *>(dev))->read_rawVerPosHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SimulatedE2BPM *>(dev))->is_rawVerPosHistory_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SimulatedE2BPM *>(dev))->is_Reset_allowed(any);}
};

//	Command GetBPMName class definition
class GetBPMNameClass : public Tango::Command
{
public:
	GetBPMNameClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetBPMNameClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetBPMNameClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SimulatedE2BPM *>(dev))->is_GetBPMName_allowed(any);}
};

//	Command GetBPMIndex class definition
class GetBPMIndexClass : public Tango::Command
{
public:
	GetBPMIndexClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetBPMIndexClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetBPMIndexClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SimulatedE2BPM *>(dev))->is_GetBPMIndex_allowed(any);}
};

//	Command Fault class definition
class FaultClass : public Tango::Command
{
public:
	FaultClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	FaultClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~FaultClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SimulatedE2BPM *>(dev))->is_Fault_allowed(any);}
};

//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~OnClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SimulatedE2BPM *>(dev))->is_On_allowed(any);}
};


/**
 *	The SimulatedE2BPMClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  SimulatedE2BPMClass : public Tango::DeviceClass
#else
class SimulatedE2BPMClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(SimulatedE2BPMClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPMClass::Additional DServer data members

	public:
		//	Class properties data members
		//	OrbitDevName:	Tango device name of simulatedebeamorbit-srv.
		//  simulatedebeamorbit-srv acts as buffer for limiting the load to the ring simulator.
		std::string	orbitDevName;
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static SimulatedE2BPMClass *init(const char *);
		static SimulatedE2BPMClass *instance();
		~SimulatedE2BPMClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		SimulatedE2BPMClass(std::string &);
		static SimulatedE2BPMClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	SimulatedE2BPM_H
